(defun recover-calibration-values (lines)
  (mapcar (lambda (line)
            (let* ((first-digit (find-if #'digit-char-p line))
                   (last-digit (find-if #'digit-char-p (reverse line)))
                   (digits-string (concatenate 'string (string first-digit) (string last-digit))))
              (parse-integer digits-string :radix 10)))
          lines))

(defun read-lines-from-file (file-path)
  "Reads a file line by line and returns a list of strings."
  (with-open-file (stream file-path :direction :input)
    (loop for line = (read-line stream nil)
          while line
          collect line)))

;; Provided document values
;(let ((calibration-lines '("1abc2" "pqr3stu8vwx" "a1b2c3d4e5f" "treb7uchet")))
(let ((calibration-lines (read-lines-from-file "day01.input")))
  (let ((calibration-values (recover-calibration-values calibration-lines)))
    (format t "Calibration Values: ~a~%" calibration-values)
    (format t "Sum of Calibration Values: ~a~%" (reduce #'+ calibration-values))))
